#version 330 core

uniform float progress;
uniform float time;

in vec2 uvIn;

out vec4 outColor;

#include noise3d.ash

// Progress = tension.
void main() {
    // No x here?
    float noise = abs(gnoise(vec3(uvIn.x * 0, uvIn.y / 2, time * 2)));
    float uvProgress = uvIn.x + noise * 0.1;

    vec3 blue = vec3(0.0, 1.0, 1.0);
    vec3 brown = vec3(0.6, 0.15, 0);

    if(uvProgress > progress)
        discard;

    float a = smoothstep(progress - 0.05, progress, uvProgress);

    float alpha = smoothstep(progress + 0.02, progress, uvProgress);
    float edge = abs(uvIn.y);
    alpha *= smoothstep(1.0, 0.9, edge);

    outColor.rgb = mix(blue, brown, uvProgress);

    vec3 brighter = outColor.rgb + vec3(0.2);

    outColor.rgb = mix(outColor.rgb, brighter, a);

    outColor.a = alpha;

    if(uvIn.x < 0.02 || uvIn.x > 0.98) {
        outColor.rgb = vec3(0.2, 0.2, 0.2);
    }
}